<template>
    <Tree
        ref="treRef"
        @check-change="handleCheckChange"
        :default-checked-keys="defaultCheckedKeys"
        :show-checkbox="props.showCheckbox"
        :data="tree"
    />
</template>

<script lang="ts" setup>
import { ref, nextTick } from 'vue'
import Tree from '../device.vue'
import { getDeviceTree } from '@/api/cs-device-boot/csLedger'
import { useConfig } from '@/stores/config'
defineOptions({
    name: 'govern/deviceTree'
})
const props = withDefaults(
    defineProps<{
        showCheckbox?: boolean
        defaultCheckedKeys?: any
    }>(),
    {
        showCheckbox: false,
        defaultCheckedKeys: []
    }
)

const emit = defineEmits(['init', 'checkChange'])
const config = useConfig()
const tree = ref()
const treRef = ref()
getDeviceTree().then(res => {
    console.log(res, '000000')
    let arr: any[] = []
    //治理设备
    res.data.map((item: any) => {
        if (item.name == '治理设备') {
            item.children.forEach((item: any) => {
                item.icon = 'el-icon-HomeFilled'
                item.color = config.getColorVal('elementUiPrimary')
                item.children.forEach((item2: any) => {
                    item2.icon = 'el-icon-List'
                    item2.color = config.getColorVal('elementUiPrimary')
                    item2.children.forEach((item3: any) => {
                        item3.icon = 'el-icon-Platform'
                        item3.color = config.getColorVal('elementUiPrimary')
                        if (item3.comFlag === 1) {
                            item3.color = '#e26257 !important'
                        }
                        arr.push(item3)
                    })
                })
            })
        } else if (item.name == '便携式设备') {
            item.children.forEach((item: any) => {
                item.icon = 'el-icon-Platform'
                item.color = config.getColorVal('elementUiPrimary')
                item.color = '#e26257 !important'
                item.color = item.comFlag === 3 ? config.getColorVal('elementUiPrimary') : '#e26257 !important'
                item.children.forEach((item2: any) => {
                    item2.icon = 'el-icon-Platform'
                    item2.color = item2.comFlag === 3 ? config.getColorVal('elementUiPrimary') : '#e26257 !important'
                    // item2.children.forEach((item3: any) => {
                    //     item3.icon = 'el-icon-Platform'
                    //     item3.color = config.getColorVal('elementUiPrimary')
                    //     if (item3.comFlag === 1) {
                    //         item3.color = '#e26257 !important'
                    //     }
                    //     arr.push(item3)
                    // })
                })
            })
        }
    })
    tree.value = res.data
    nextTick(() => {
        if (arr.length) {
            console.log(treRef.value.treeRef1, '99999999')
            treRef.value.treeRef1.setCurrentKey(arr[0].id)
            // 注册父组件事件
            emit('init', {
                level: 2,
                ...arr[0]
            })
        } else {
            emit('init')
        }
    })
})
const handleCheckChange = (data: any, checked: any, indeterminate: any) => {
    emit('checkChange', {
        data,
        checked,
        indeterminate
    })
}
</script>
